---
stages:
  - pre-commit
  - test-suite
  - build
  - publish
  - pop-release

include:
  - local: "cicd/variables.yml"
  - project: saltstack/pop/cicd/ci-templates
    file: /lint/pre-commit-run-all.yml
  - project: saltstack/pop/cicd/ci-templates
    file: /release/pop_release.yml

pre-commit-run-all:
  image: registry.gitlab.com/saltstack/pop/cicd/containers/alpinelint:py39

.test-suite:
  stage: test-suite
  variables:
    DOCKER_HOST: tcp://docker:2375
    DOCKER_DRIVER: overlay2
    DOCKER_TLS_CERTDIR: "" # Disable TLS
    FF_NETWORK_PER_BUILD: "true"
  services:
    - name: docker:dind
      alias: docker
  needs:
    - pre-commit-run-all
  script:
    - apt-get update
    - apt-get install -y docker.io
    - >
      for i in {1..20}; do
        docker version && break || sleep 15;
        if [ $i -eq 20 ]; then
          echo "Failed to run docker version after 20 attempts.";
          exit 1;
        fi
      done
    - python3 -m pip install nox
    - nox -e tests-3 -- -vv
  artifacts:
    when: always
    paths:
      - artifacts
    reports:
      junit: artifacts/junit-report.xml
    expire_in: 30 days

tests-3.8:
  extends: .test-suite
  image: python:3.8

tests-3.9:
  extends: .test-suite
  image: python:3.9

tests-3.10:
  extends: .test-suite
  image: python:3.10

build-docs:
  stage: build
  image: python:3.8
  script:
    - pip install -U pip setuptools wheel nox
    - nox -e 'docs-html(clean=True)'
    - mv docs/_build/html html
  artifacts:
    paths:
      - html
    expire_in: 30 days

publish_pypi:
  stage: publish
  image: python:3.8
  script:
    - pip install twine wheel
    - python setup.py sdist bdist_wheel
    - twine upload --repository ${PYPI_REPO} dist/*
  rules:
    - if: '$CI_COMMIT_REF_PROTECTED == "true" && $CI_COMMIT_TAG != null && $CI_PROJECT_PATH == $CICD_UPSTREAM_PATH'
